%%  demo 1: SpInPHASE(Z is for complex data)
%
%
%  ---------------------------------------------------------------------
%  data description
%  ---------------------------------------------------------------------
%
% Original phase: Gaussian elevation
%
% observation model  z = exp(j phi) + n
%
%%  begin demo

clear all
close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Exp -  Long Peaks
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fid=fopen('longs.152x458.mask','r','b');
mask = fread(fid,'uint8');
mask = reshape(mask, [152,458]);
mask = mask/255;

%fatten mask one pixel
mask = 1-fatten(1-mask);
mask(:,1) = 0;
mask(:,end) = 0;
mask(1,:) = 0;
mask(end,:) = 0;


fid=fopen('longs.152x458.corr','r','b');
corr = fread(fid,'uint8');
corr = reshape(corr, [152,458]);
corr = corr/255;
% [NA, corr] = BM3D(1, corr, 0.15*255);

fid=fopen('longs.152x458.phase','r','b');
phase = fread(fid,'uint8');
phase = reshape(phase, [152,458]);
phase = wrap(phase/255*(2*pi));
[M,N]=size(phase);

fid=fopen('longs.152x458.surf','r','b');
surf = fread(fid,'float');
surf = reshape(surf, [152,458]);

load longs.qual1.mat
% qual = corr>0.45;


% varphi = surf.*mask;% 
% [M,N] = size(varphi);% 
% z = exp(1i*phase);
% % z = z.*mask;
% % compute the interferogram;
% phi = angle(z); 
% % allsigma = 0.3;
% % sigma = allsigma/sqrt(2);
%%              PUMA
[dh dv] = linefg(mask&qual);
%  set qualitymaps to PUMA
qualmap(:,:,1) = 0.99*dh;
qualmap(:,:,2) = 0.99*dv;
% we are  using quadractic potencial - discontinuities are infered beforehand)
potential.quantized = 'no';
potential.threshold = 0.5;

tic;
unwrap_phase_PUMA =puma_ho(phase,2,'potential',potential,'qualitymaps', qualmap,'verbose','no');
toc;
%phi_hat_SpInPHASE = angle(exp(I*(phi_pearls + phi_hat_SpInPHASE )));
t_PUMA = toc;
unwrap_phase_PUMA = unwrap_phase_PUMA.*mask;

numberpix = sum(sum(mask.*qual));
ttemp = round(sum(sum((unwrap_phase_PUMA-surf).*mask.*qual))/(2*pi*numberpix));
unwrap_phase_PUMA = unwrap_phase_PUMA-ttemp*2*pi;

unwrap_err = (unwrap_phase_PUMA-surf).*mask.*qual;
errmask = abs(unwrap_err)>pi;
AverageError_PUMA = sqrt(sum(sum((unwrap_phase_PUMA-surf).^2.*mask.*qual))/numberpix);
NELP_PUMA = sum(errmask(:));
%%                QPBOI
tic;
unwrap_phase_QPBOI =QPBOI(phase,2,'potential',potential,'qualitymaps', qualmap,'base',qual.*mask);
toc;
%phi_hat_SpInPHASE = angle(exp(I*(phi_pearls + phi_hat_SpInPHASE )));
t_QPBOI = toc;
unwrap_phase_QPBOI = unwrap_phase_QPBOI.*mask.*qual;
unwrap_phase_QPBOI = Fixwrapphase(unwrap_phase_QPBOI,qual);

numberpix = sum(sum(mask.*qual));
ttemp = round(sum(sum((unwrap_phase_QPBOI-surf).*mask.*qual))/(2*pi*numberpix));
unwrap_phase_QPBOI = unwrap_phase_QPBOI-ttemp*2*pi;

unwrap_err = (unwrap_phase_QPBOI-surf).*mask.*qual;
errmask = abs(unwrap_err)>pi;
AverageError_QPBOI = sqrt(sum(sum((unwrap_phase_QPBOI-surf).^2.*mask.*qual))/numberpix);
NELP_QPBOI = sum(errmask(:));
%%                  Goldstein branch cut
gmask = qual.*mask;
max_box_radius=4;                           %Maximum search box radius (pixels)
threshold_std=5;                            %Number of noise standard deviations used for thresholding the magnitude image
tic;
residue_charge=PhaseResidues(phase, gmask);                            %Calculate phase residues
branch_cuts=BranchCuts(residue_charge, max_box_radius, gmask);            %Place branch cuts
[unwrap_phase_Goldstein, rowref, colref]=FloodFill(phase, branch_cuts, gmask);   %Flood fill phase unwrapping
toc;

t_GoldsteinCut = toc;
unwrap_phase_Goldstein = unwrap_phase_Goldstein.*mask.*qual;
unwrap_phase_Goldstein = Fixwrapphase(unwrap_phase_Goldstein,qual.*mask);

numberpix = sum(sum(mask.*qual));
ttemp = round(sum(sum((unwrap_phase_Goldstein-surf).*mask.*qual))/(2*pi*numberpix));
unwrap_phase_Goldstein = unwrap_phase_Goldstein-ttemp*2*pi;

unwrap_err = (unwrap_phase_Goldstein-surf).*mask.*qual;
errmask = abs(unwrap_err)>pi;
AverageError_Goldstein = sqrt(sum(sum((unwrap_phase_Goldstein-surf).^2.*mask.*qual))/numberpix);
NELP_Goldstein = sum(errmask(:));
%%                    Snaphu
z = exp(1i*phase);
realz = real(z);
imagz = imag(z);
realz1 = reshape(realz,1,M*N);
imagz1 = reshape(imagz,1,M*N);
write1 = [realz1;imagz1];
writedata = reshape(write1,2*M,N);

mask1 =  reshape(mask.*qual.*corr,1,M*N);
write2 = [mask1;mask1];
writemask = reshape(write2,2*M,N);
if exist('tmpwph.dat','file')
    dos('del tmpwph.dat');
end
fdin = fopen('tmpwph.dat', 'w');
%  number nodes
if 2*M*N ~= fwrite(fdin, writedata, 'float')
   fprintf(2,'Error wrinting to tmpwph.dat');
   fclose(fdin);
   return;
end
fclose(fdin);
fprintf('finish wrinting to tmpwph.dat\n');

if exist('tmpmask.dat','file')
    dos('del tmpmask.dat');
end
fdin1 = fopen('tmpmask.dat', 'w');
%  number nodes
if 2*M*N ~= fwrite(fdin1, writemask, 'float')
   fprintf(2,'Error wrinting to tmpmask.dat');
   fclose(fdin1);
   return;
end
fclose(fdin1);
fprintf('finish wrinting to tmpmask.dat\n');

st = computer; %teste machine
if strcmp(st,'PCWIN64' )
    tic;
    !snaphu_win\win64\snaphu.exe -c tmpmask.dat tmpwph.dat 152
    toc;
elseif strcmp(st,'PCWIN' )
    tic;
    !snaphu_win\win32\snaphu.exe -c tmpmask.dat tmpwph.dat 152
    toc;
else
    fprintf('\nThis code run only on PC\n')
end
clear st;
t_Snaphu = toc;
fid = fopen( 'snaphu.out', 'r' );
if fid == -1
	error( ['Cannot open file ' ,results_fname] );
end

label_size = 'float';
unwrap = fread( fid, label_size );
fclose(fid);
unwrap = reshape(unwrap,2*M,N);
unwrap = unwrap(M+1:2*M,:);

unwrap_phase_Snaphu = unwrap.*mask.*qual;
unwrap_phase_Snaphu = Fixwrapphase(unwrap_phase_Snaphu,qual.*mask);

numberpix = sum(sum(mask.*qual));
ttemp = round(sum(sum((unwrap_phase_Snaphu-surf).*mask.*qual))/(2*pi*numberpix));
unwrap_phase_Snaphu = unwrap_phase_Snaphu-ttemp*2*pi;

unwrap_err = (unwrap_phase_Snaphu-surf).*mask.*qual;
errmask = abs(unwrap_err)>pi;
AverageError_Snaphu = sqrt(sum(sum((unwrap_phase_Snaphu-surf).^2.*mask.*qual))/numberpix);
NELP_Snaphu = sum(errmask(:));




fprintf('\n\n------Output Information------\n');
fprintf('AverageError_PUMA  = %2.3f\n', AverageError_PUMA);
fprintf('NELP_PUMA = %2.3f\n', NELP_PUMA);
fprintf('time of computation PUMA: %f\n',t_PUMA);

fprintf('\n\n------Output Information------\n');
fprintf('AverageError_QPBOI  = %2.3f\n', AverageError_QPBOI);
fprintf('NELP_QPBOI = %2.3f\n', NELP_QPBOI);
fprintf('time of computation QPBOI: %f\n',t_QPBOI);

fprintf('\n\n------Output Information------\n');
fprintf('AverageError_Goldstein  = %2.3f\n', AverageError_Goldstein);
fprintf('NELP_Goldstein = %2.3f\n', NELP_Goldstein);
fprintf('time of computation Goldstein: %f\n',t_GoldsteinCut);

fprintf('\n\n------Output Information------\n');
fprintf('AverageError_Snaphu  = %2.3f\n', AverageError_Snaphu);
fprintf('NELP_Snaphu = %2.3f\n', NELP_Snaphu);
fprintf('time of computation Snaphu: %f\n',t_Snaphu);
figure(1);
surfl(unwrap_phase_PUMA.*mask);shading interp;axis off;colormap gray;
figure(2);
surfl(unwrap_phase_QPBOI.*mask);shading interp;axis off;colormap gray;
figure(3);
surfl(unwrap_phase_Goldstein.*mask);shading interp;axis off;colormap gray;
figure(4);
surfl(unwrap_phase_Snaphu.*mask);shading interp;axis off;colormap gray;


